# Usage
Notes and comments on some features, installation and usage can be found in [README](/README.md).

## Playback Speed
This feature allows faster downloads by forcing the player to decode audio quicker, it does not generate files of lower quality. The slider is limited to 20x maximum, but any value can be set in the textbox on the left side.
Notes:
- Speed >= ~30x will cause the player to stutter and silently spam requests to a Spotify API, which could increase the changes of your account getting banned or rate limited.
- Speed >= ~200x will saturate CPU (use 100% of a core or more). This could increase the chance of crashes or unexpected behavior.
Stuttering may happen just after changing the value, but it generally stops on the next song. There also seems to be a memory leak related to it, but it goes away after some time. (?)

## Config Files
Since `v2.2.0`, configuration files are stored in `%appdata%/Soggfy` so they are preserved between updates.

## High quality AAC
FFmpeg's native AAC encoder is known to generate poor quality files[^1][^2], the alternative encoder _libfdk_aac_ is not distributed in popular builds due to licensing issues (also because PowerShell doesn't support .7z); you need to either build or download it from somewhere else:
- https://github.com/AnimMouse/ffmpeg-autobuild/releases
- https://github.com/marierose147/ffmpeg_windows_exe_with_fdk_aac/releases

To install it, add the binary folder in your `%PATH%` or copy it to the Soggfy folder (i.e. `Soggfy/ffmpeg/ffmpeg.exe`). Then select the "Custom" option in the format setting, and use these values:
- Arguments: `-c:a libfdk_aac -b:a 192k -disposition:v attached_pic -c:v copy` (you may change `192k` to your preferred bitrate)
- Extension: either `m4a` or `mp4`

Note that some iPods may have issues playing AAC files generated by ffmpeg (https://trac.ffmpeg.org/ticket/7747)

# Links
[^1]: https://trac.ffmpeg.org/wiki/Encode/HighQualityAudio
[^2]: https://trac.ffmpeg.org/wiki/Encode/AAC
